"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTempDir = void 0;
const os_1 = __importDefault(require("os"));
const path_1 = __importDefault(require("path"));
const process_1 = __importDefault(require("process"));
const FS = __importStar(require("./fs"));
function createTempDir(name) {
    const nodeModules = findPkgNodeModules(process_1.default.cwd());
    const tempDir = nodeModules
        ? path_1.default.join(nodeModules, '.cache')
        : os_1.default.tmpdir();
    if (nodeModules) {
        FS.mkdirSync(tempDir, { recursive: true });
    }
    return FS.mkdtempSync(path_1.default.join(tempDir, `${name}-`));
}
exports.createTempDir = createTempDir;
function findPkgNodeModules(cwd) {
    let dir = path_1.default.resolve(cwd);
    const rootDir = path_1.default.parse(dir).root;
    while (dir !== rootDir) {
        const nodeModules = path_1.default.join(dir, 'node_modules');
        if (isWritableDir(nodeModules)) {
            return nodeModules;
        }
        dir = path_1.default.dirname(dir);
    }
    return null;
}
function isWritableDir(path) {
    try {
        if (!FS.statSync(path).isDirectory()) {
            return false;
        }
        FS.accessSync(path, FS.constants.W_OK);
        return true;
    }
    catch (_a) {
        return false;
    }
}
//# sourceMappingURL=tempDir.js.map